-- originaly By PeterJ (30-11-2010)
-- changed to fit the NH 8970 by timbertaz



NH8970 = {};

function NH8970.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function NH8970:load(xmlFile)

    self.extrawheel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.extrawheel#index"));
    self.extrawheel1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.extrawheel1#index"));
    self.extrawheel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.extrawheel2#index"));
    self.extrawheel3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.extrawheel3#index"));

    self.terrawheel1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.terrawheel1#index"));
    self.terrawheel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.terrawheel2#index"));
    self.terrawheel3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.terrawheel3#index"));
    self.terrawheel4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.terrawheel4#index"));

    self.standardwheel1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.standardwheel1#index"));
    self.standardwheel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.standardwheel2#index"));
    self.standardwheel3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.standardwheel3#index"));
    self.standardwheel4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.standardwheel4#index"));

    self.weight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.weight#index"));
    self.weight1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.weight1#index"));
    self.wide = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.NH8970.wide#index"));
    
local rotationPartNodeLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NH8970.rotationPartLeft#index"));
    if rotationPartNodeLeft ~= nil then
        self.rotationPartLeft = {};
        self.rotationPartLeft.node = rotationPartNodeLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NH8970.rotationPartLeft#minRot"));
        self.rotationPartLeft.minRot = {};
        self.rotationPartLeft.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NH8970.rotationPartLeft#maxRot"));
        self.rotationPartLeft.maxRot = {};
        self.rotationPartLeft.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartLeft.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartLeft.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartLeft.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NH8970.rotationPartLeft#rotTime"), 100)*1000;
        self.rotationPartLeft.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.NH8970.rotationPartLeft#touchRotLimit"), 10));
    end;
   
local rotationPartNodeRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.NH8970.rotationPartRight#index"));
    if rotationPartNodeRight ~= nil then
        self.rotationPartRight = {};
        self.rotationPartRight.node = rotationPartNodeRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NH8970.rotationPartRight#minRot"));
        self.rotationPartRight.minRot = {};
        self.rotationPartRight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.NH8970.rotationPartRight#maxRot"));
        self.rotationPartRight.maxRot = {};
        self.rotationPartRight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartRight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartRight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartRight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.NH8970.rotationPartRight#rotTime"), 100)*1000;
        self.rotationPartRight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.NH8970.rotationPartRight#touchRotLimit"), 10));
    end;




	self.extrawheels = false;
        self.extrawheels1 = false;
        self.extrawheels2 = false;
        self.extrawheels3 = false;

        self.terrawheels1 = false;
        self.terrawheels2 = false;
        self.terrawheels3 = false;
        self.terrawheels4 = false;
        
        self.standardwheels1 = true;
        self.standardwheels2 = true;
        self.standardwheels3 = true;
        self.standardwheels4 = true;

	self.weights = true;
        self.weights1 = true;
        self.wides = false;
        self.rotationMaxLeft = false;
        self.rotationMaxRight = false;

        


	self.controlpath = Utils.getFilename("Textures/info.png", self.baseDirectory);
    self.helpPoxX = 0.87;
    self.helpPoxY = 0.41;
    self.helpWidth = 0.12;
    self.helpHeight = 0.46;
    self.helpOverlay = Overlay:new("help", self.controlpath, self.helpPoxX, self.helpPoxY, self.helpWidth, self.helpHeight);
    self.bcActive = false;

end;

function NH8970:keyEvent(unicode, sym, modifier, isDown)

		if isDown and sym == Input.KEY_9 then
			self.bcActive = not self.bcActive;
		end;

	if isDown and sym == Input.KEY_y then
		self.rotationMaxLeft = not self.rotationMaxLeft;
	end;
        if isDown and sym == Input.KEY_t then
		self.rotationMaxRight = not self.rotationMaxRight;
	end;

        if isDown and sym == Input.KEY_5 then
		self.wides = not self.wides;
	end;
	
	
	if isDown and sym == Input.KEY_7 then
		self.weights = not self.weights;
                self.weights1 = not self.weights1;
  
	end;
        if isDown and sym == Input.KEY_u then
		self.terrawheels1 = not self.terrawheels1;
                self.terrawheels2 = not self.terrawheels2;
                self.terrawheels3 = not self.terrawheels3;
                self.terrawheels4 = not self.terrawheels4;
                
	end;
       if isDown and sym == Input.KEY_u then
		self.standardwheels1 = not self.standardwheels1;
                self.standardwheels2 = not self.standardwheels2;
                self.standardwheels3 = not self.standardwheels3;
                self.standardwheels4 = not self.standardwheels4;
                
	end;
	
	if isDown and sym == Input.KEY_8 then
		self.extrawheels = not self.extrawheels;
		self.extrawheels1 = not self.extrawheels1;
                self.extrawheels2 = not self.extrawheels2;
                self.extrawheels3 = not self.extrawheels3;
	end;
end;

function NH8970:update(dt)

if self.rotationPartRight ~= nil then
        local x, y, z = getRotation(self.rotationPartRight.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight.maxRot, self.rotationPartRight.minRot, 3, self.rotationPartRight.rotTime, dt, not self.rotationMaxRight);
        setRotation(self.rotationPartRight.node, unpack(newRot));
    end;

    if self.rotationPartLeft ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft.maxRot, self.rotationPartLeft.minRot, 3, self.rotationPartLeft.rotTime, dt, not self.rotationMaxLeft);
        setRotation(self.rotationPartLeft.node, unpack(newRot));
    end;

    if self:getIsActiveForInput() and self.isEntered then



		if InputBinding.hasEvent(InputBinding.EXTRAWHEEL) then
		   	if self.extrawheels == false then
		   	   self.extrawheels = true
		   	else
		   		self.extrawheels = false
		   	end;
		end;		

        if InputBinding.hasEvent(InputBinding.EXTRAWHEEL1) then
		   	if self.extrawheels1 == false then
		   	   self.extrawheels1 = true
		   	else
		   		self.extrawheels1 = false
		   	end;
		end;

if InputBinding.hasEvent(InputBinding.EXTRAWHEEL2) then
		   	if self.extrawheels2 == false then
		   	   self.extrawheels2 = true
		   	else
		   		self.extrawheels2 = false
		   	end;
		end;

if InputBinding.hasEvent(InputBinding.EXTRAWHEEL3) then
		   	if self.extrawheels3 == false then
		   	   self.extrawheels3 = true
		   	else
		   		self.extrawheels3 = false
		   	end;
		end;

        if InputBinding.hasEvent(InputBinding.WEIGHT) then
		   	if self.weights == false then
		   	   self.weights = true
		   	else
		   		self.weights = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.WEIGHT1) then
		   	if self.weights1 == false then
		   	   self.weights1 = true
		   	else
		   		self.weights1 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.WIDE) then
		   	if self.wides == false then
		   	   self.wides = true
		   	else
		   		self.wides = false
		   	end;
		end;

 if InputBinding.hasEvent(InputBinding.TERRAWHEEL1) then
		   	if self.terrawheels1 == false then
		   	   self.terrawheels1 = true
		   	else
		   		self.terrawheels1 = false
		   	end;
		end;

if InputBinding.hasEvent(InputBinding.TERRAWHEEL2) then
		   	if self.terrawheels2 == false then
		   	   self.terrawheels2 = true
		   	else
		   		self.terrawheels2 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.TERRAWHEEL3) then
		   	if self.terrawheels3 == false then
		   	   self.terrawheels3 = true
		   	else
		   		self.terrawheels3 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.TERRAWHEEL4) then
		   	if self.terrawheels4 == false then
		   	   self.terrawheels4 = true
		   	else
		   		self.terrawheels4 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.STANDARDWHEEL1) then
		   	if self.standardwheels1 == false then
		   	   self.standardwheels1 = true
		   	else
		   		self.standardwheels1 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.STANDARDWHEEL2) then
		   	if self.standardwheels2 == false then
		   	   self.standardwheels2 = true
		   	else
		   		self.standardwheels2 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.STANDARDWHEEL3) then
		   	if self.standardwheels3 == false then
		   	   self.standardwheels3 = true
		   	else
		   		self.standardwheels1 = false
		   	end;
		end;
if InputBinding.hasEvent(InputBinding.STANDARDWHEEL4) then
		   	if self.standardwheels4 == false then
		   	   self.standardwheels4 = true
		   	else
		   		self.standardwheels4 = false
		   	end;
		end;








	end;	
		
if self.isEntered then



	-- extrawheel
		if self.extrawheels then
				setVisibility(self.extrawheel, self.extrawheels);
		else
				setVisibility(self.extrawheel, self.extrawheels, false);
		end;

	
	-- extrawheel1
		if self.extrawheel1 then
				setVisibility(self.extrawheel1, self.extrawheels1);
		else
				setVisibility(self.extrawheel1, self.extrawheels1, false);
		end;

-- extrawheel2
		if self.extrawheel2 then
				setVisibility(self.extrawheel2, self.extrawheels1);
		else
				setVisibility(self.extrawheel2, self.extrawheels1, false);
		end;

-- extrawheel3
		if self.extrawheel3 then
				setVisibility(self.extrawheel3, self.extrawheels1);
		else
				setVisibility(self.extrawheel3, self.extrawheels1, false);
		end;


	-- weight
		if self.weight then
				setVisibility(self.weight, self.weights);
		else
				setVisibility(self.weight, self.weights, false);
		end;
-- weight1
		if self.weight1 then
				setVisibility(self.weight1, self.weights);
		else
				setVisibility(self.weight1, self.weights, false);
		end;
-- weight2
		if self.wide then
				setVisibility(self.wide, self.wides);
		else
				setVisibility(self.wide, self.wides, false);
		end;

-- terrawheel
		if self.terrawheels1 then
				setVisibility(self.terrawheel1, self.terrawheels1);
		else
				setVisibility(self.terrawheel1, self.terrawheels1, false);
		end;
-- terrawheel
		if self.terrawheels2 then
				setVisibility(self.terrawheel2, self.terrawheels2);
		else
				setVisibility(self.terrawheel2, self.terrawheels2, false);
		end;
-- terrawheel
		if self.terrawheels3 then
				setVisibility(self.terrawheel3, self.terrawheels3);
		else
				setVisibility(self.terrawheel3, self.terrawheels3, false);
		end;
-- terrawheel
		if self.terrawheels4 then
				setVisibility(self.terrawheel4, self.terrawheels4);
		else
				setVisibility(self.terrawheel4, self.terrawheels4, false);
		end;
-- standardwheel
		if self.standardwheels1 then
				setVisibility(self.standardwheel1, self.stndardwheels1);
		else
				setVisibility(self.standardwheel1, self.standardwheels1, false);
		end;
-- standardwheel
		if self.standardwheels2 then
				setVisibility(self.standardwheel2, self.stndardwheels2);
		else
				setVisibility(self.standardwheel2, self.standardwheels2, false);
		end;
-- standardwheel
		if self.standardwheels3 then
				setVisibility(self.standardwheel3, self.stndardwheels3);
		else
				setVisibility(self.standardwheel3, self.standardwheels3, false);
		end;
-- standardwheel
		if self.standardwheels4 then
				setVisibility(self.standardwheel4, self.stndardwheels4);
		else
				setVisibility(self.standardwheel4, self.standardwheels4, false);
		end;




end;

end;

function NH8970:draw()

	 if self.helpOverlay ~= nil then
		if self.bcActive then
		self.helpOverlay:render();
		end;
	end;
		if self.bcActive then	
			g_currentMission:addExtraPrintText("Key 9: NH 8970 Info Off");
		else
			g_currentMission:addExtraPrintText("Key 9: NH 8970 Info On");
		end;

end;

function NH8970:onEnter()
end;

function NH8970:onLeave()
end;

function NH8970:delete()
end;

function NH8970:mouseEvent(posX, posY, isDown, isUp, button)
end;





